package eu.ocopomo.chat;

import java.util.List;
import java.util.Set;
import org.json.JSONObject;

public class ChatRoom {
    
    private String id;
    private Set<String> jids;
    private String subject;
    private List<JSONObject> history;
    
    public ChatRoom(String id, Set<String> jids, String subject, List<JSONObject> history) {
        this.id = id;
        this.jids = jids;
        this.subject = subject;
        this.history = history;
    }
    
    public synchronized void addOccupantToRoom(String jid){
        this.jids.add(jid);
    }
    
    public synchronized void removeOccupantFromRoom(String jid){
        this.jids.remove(jid);
    }
    
    public synchronized void addToHistory(JSONObject msg){
        this.history.add(msg);
    }
    
    public synchronized void setSubject(String subject){
        this.subject = subject;
    }
    
    public boolean hasOccupant(String jid){
        if(jids.contains(jid)) return true;
        else return false;
    }
    
    public String getSubject(){
        return subject;
    }
    
    public Set<String> getJids(){
        return jids;
    }
    
    public String getRoomId(){
        return id;
    }
    
    public List<JSONObject> getHistory(){
        return history;
    }
}
