<import resource="classpath:alfresco/templates/webscripts/org/alfresco/repository/requestutils.lib.js">

function getFolder()
{
   var name = "Chats";
   container = getRequestNode();
   node = container.childByNamePath(name);
   if (node === null)
   {
      node = container.createFolder(name);
   }

   return node;
}

function getContent(json)
{
   var persons = {};
   var occupants = json.getJSONArray('occupants');
   
   for (var i = 0; i < occupants.length(); i++) {
       var name = occupants.get(i);
       persons[name + "@ocopomo.eu"] = people.getPerson(name);
       if (persons[name + "@ocopomo.eu"] == null) {
          persons[name + "@ocopomo.eu"] = { "properties" : {"firstName" : "", "lastName" : name} };
       }
   }
   
   var content = "<html><body><h3>" + json.get('subject') + "</h3>";

   var history = json.getJSONArray('history');
   for (var i = 0; i < history.length(); i++) {
       var msg = history.getJSONObject(i);
       var from = persons[msg.get("from")];

       if (msg.has('body')) {
          content += "<div>" + from.properties.firstName + " " + from.properties.lastName + " said (" +  utils.fromISO8601(msg.get('stamp')) + "):</div>"; 
          content += "<div>" + msg.get('body') + "</div>";
       } else {
          content += "<div>" + from.properties.firstName + " " + from.properties.lastName + ' changed subject to "' + msg.get('subject') + '" (' +  utils.fromISO8601(msg.get('stamp')) + "):</div>"; 
       }
   }
   
   content += "</body></html>";
   return content;
}

function createHistory(json)
{
   var name = json.get('name');
   var title = null;
   var description = null;

   if (json.has("title")) {
      title = json.get("title");
   }
   if (json.has("description")) {
      description = json.get("description");
   }
   var content = getContent(json);
   var tags = ["chat"];

   var folder = getFolder();
   var historyNode = folder.createFile(name);

   if (title != null) historyNode.properties.title = title;
   if (description != null) historyNode.properties.description = description;
   historyNode.mimetype = "text/html";
   historyNode.content = content;
   historyNode.tags = tags;
   historyNode.save();
   
   return historyNode;
}

function main()
{
   /*
   var json = {
      description: "saved chat",
      history: [{"history":"true","to":"room://2621cff0-93c9-4f2f-9125-83586269bdfa@ocopomo.eu","stamp":"2011-08-23T11:24:33.144Z","body":"new chat","from":"butka@ocopomo.eu","type":"message"},{"history":"true","to":"room://2621cff0-93c9-4f2f-9125-83586269bdfa@ocopomo.eu","stamp":"2011-08-23T11:25:19.734Z","body":"hmmmm","from":"bednar@ocopomo.eu","type":"message"},{"history":"true","to":"room://2621cff0-93c9-4f2f-9125-83586269bdfa@ocopomo.eu","stamp":"2011-08-23T11:25:26.145Z","subject":"new chat 2","from":"butka@ocopomo.eu","type":"message"},{"history":"true","to":"room://2621cff0-93c9-4f2f-9125-83586269bdfa@ocopomo.eu","stamp":"2011-08-23T11:25:40.310Z","body":"bleee","from":"butka@ocopomo.eu","type":"message"}],
      name: "new chat 2",
      occupants: ["butka", "bednar"],
      subject: "new chat 2",
      title: "New chat about X"
   };
   */

   model.node = createHistory(json);
}

main();